//
//  File.swift
//
//
//  Created by Max Nuding on 02.12.21.
//

import Foundation
import AppKit

struct Day03 {
    let inputPath: String
    
    func run() {
        let input = try! String(contentsOfFile: inputPath)
        let commands = input
            .components(separatedBy: .newlines)
            .filter { !$0.isEmpty }
            //.compactMap { MoveCommand(line: $0) }
        runA(commands)
        //runB(commands)
    }
    
    func runA(_ commands: [String]) {
        let neededForMajority = commands.count / 2
        let lastBitIndex = commands.first!.count
        var countsOnes = [Int](repeating: 0, count: lastBitIndex)
        for command in commands {
            let m = command.map { Bool.init(digit: $0)! }.map { $0 ? 1 : 0 }
            countsOnes.enumerated().forEach { (idx, elem) in
                countsOnes[idx] += m[idx]
            }
        }
        let dec = countsOnes.indices.reduce((gamma: 0, episolon: 0), { partialResult, idx in
            let isOne = countsOnes[idx] > neededForMajority
            let val = Int(truncating: NSDecimalNumber(decimal: pow(2, countsOnes.count - idx - 1)))
            var (gamma, episolon) = partialResult
            if isOne {
                gamma += val
            } else {
                episolon += val
            }
            return (gamma, episolon)
        })
        print(dec.episolon * dec.gamma)<
    }
    
    func runB(_ commands: [String]) {
        
    }
}

extension Bool {
    init?(digit: Character) {
        switch digit {
        case "0":
            self = false
        case "1":
            self = true
        default:
            return nil
        }
    }
}
